#include <bits/stdc++.h>
using namespace std;

vector <pair <int, int>> delta{{0, 1}, {1, 0}, {0, -1}, {-1, 0}};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector <vector <bool>> v(n + 2, vector <bool> (n + 2, 1));

    for (int i = 0; i <= n + 1; i++) {
        v[0][i] = 0;
        v[n + 1][i] = 0;
        v[i][0] = 0;
        v[i][n + 1] = 0;
    }

    vector <pair <int, int>> current_cells{{1, 1}};
    pair <int, int> finish_cell = {n, n};

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;

        v[x][y] = 0;
    }

    while (!current_cells.empty()) {
        vector <pair <int, int>> next_cells;

        for (auto p : current_cells) {
            for (auto dir : delta) {
                pair <int, int> cell = {p.first + dir.first, p.second + dir.second};

                if (v[cell.first][cell.second]) {
                    v[cell.first][cell.second] = 0;

                    next_cells.push_back(cell);

                    if (cell == finish_cell) {
                        cout << "YES\n";
                        return 0;
                    }
                }
            }
        }

        current_cells = next_cells;
    }

    cout << "NO\n";
    return 0;

}
