#include <bits/stdc++.h>
using namespace std;

vector <pair <int, int>> delta{{0, 1}, {1, 0}, {0, -1}, {-1, 0}, {1, 1}, {1, -1}, {-1, 1}, {-1, -1}};

int main() {

    int n, m;
    cin >> n >> m;

    map <pair <int, int>, vector <pair <int, int>>> graph;
    map <pair <int, int>, bool> check, restore;

    vector <pair <int, int>> current_cells, current_cells_2;

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;

        pair <int, int> current_cell = {x, y};
        check[current_cell] = 1;

        for (auto dir : delta) {
            pair <int, int> cell = {x + dir.first, y + dir.second};

            if (check[cell]) {
                graph[current_cell].push_back(cell);
                graph[cell].push_back(current_cell);
            }
        }

        if (x == 1) current_cells.push_back(current_cell);
        else if (y == 1) current_cells_2.push_back(current_cell);
    }

    while (!current_cells.empty()) {
        vector <pair <int, int>> next_cells;

        for (auto p : current_cells) {
            for (auto cell : graph[p]) {
                if (check[cell]) {
                    check[cell] = 0;

                    next_cells.push_back(cell);
                    if (cell.first == n || cell.second == 1) {
                        cout << "NO";
                        return 0;
                    }
                }
            }
        }

        current_cells = next_cells;
    }

    current_cells = current_cells_2;
    check = restore;

    while (!current_cells.empty()) {
        vector <pair <int, int>> next_cells;

        for (auto p : current_cells) {
            for (auto cell : graph[p]) {
                if (check[cell]) {
                    check[cell] = 0;

                    next_cells.push_back(cell);
                    if (cell.first == 1 || cell.second == n) {
                        cout << "NO";
                        return 0;
                    }
                }
            }
        }

        current_cells = next_cells;
    }

    cout << "YES";
    return 0;

}
