#include <bits/stdc++.h>
using namespace std;

int get_substrings(string s) {
    //cout << s << '\n';

    vector <pair <int, int>> brackets;
    stack <int> st;

    for (int i = 0; i < s.size(); i++) {
        char c = s[i];

        if (c == '(') {
            st.push(i);
            brackets.push_back({i + 1, s.size()});
        }

        if (c == ')' && st.empty()) brackets.push_back({-1, s.size()});

        if (c == ')' && !st.empty()) {
            pair <int, int> p = {st.top(), i};
            st.pop();

            while (!brackets.empty() && brackets.back() > p) brackets.pop_back();
            brackets.push_back(p);
        }

    }

    int sum = 0, streak = 0;

    //for (auto p : brackets) cout << p.first << ' ' << p.second << '\n';

    for (auto p : brackets) {
        if (p.second == s.size()) streak = 0;
        else {
            streak++;
            sum += streak;

            sum += get_substrings(s.substr(p.first + 1, p.second - p.first - 1));
        }
    }

    return sum;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    cout << get_substrings(s) << endl;
    return 0;

}
