#include<bits/stdc++.h>
using namespace std;
int main()
{
    int n, m;
    cin>>n>>m;
    char table[n][n];
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            table[i][j] = '.';
        }
    }
    for(int i = 0; i < m; i++)
    {
        int x, y;
        cin>>x>>y;
        table[x-1][y-1] = '#';
    }

    vector<pair<int, int> > curr;
    curr.push_back({0, 0});
    vector<pair<int, int> > dirs;
    dirs.push_back({1, 0});
    dirs.push_back({-1, 0});
    dirs.push_back({0, 1});
    dirs.push_back({0, -1});

    for(int t = 1; curr.size(); t++)
    {
        vector<pair<int, int> > next;
        for(int i = 0; i < curr.size(); i++)
        {
            for(int j = 0; j < dirs.size(); j++)
            {
                int x = curr[i].first+dirs[j].first;
                int y = curr[i].second+dirs[j].second;
                if(x >= n || x < 0 || y >= n || y < 0)
                {
                    continue;
                }
                if(table[x][y] == '#')
                {
                    continue;
                }
                if(x == n-1 && y == n-1)
                {
                    cout<<"YES";
                    return 0;
                }
                table[x][y] = '#';
                next.push_back({x, y});
            }
        }
        curr = next;
    }
    cout<<"NO";
    return 0;
}
