#include<bits/stdc++.h>
using namespace std;
int main()
{
    int n, m;
    cin>>n>>m;
    vector<pair<int, int> > v;
    bool hasSeen[m][m] = {false};
    int maxX = 0, maxY = 0;
    for(int i = 0; i < m; i++)
    {
        int x, y;
        cin>>x>>y;
        x--;
        y--;
        maxX = max(maxX, x);
        maxY = max(maxY, y);

        if(!hasSeen[x][y])
        {
            v.push_back({x, y});
            hasSeen[x][y] = true;
        }
    }

    bool one = false;
    bool two = false;

    pair<int, int> p;
    for(int i = 0; i < v.size(); i++)
    {
        if(v[i].first == 0)
        {
            one = true;
            p = {v[i].first, v[i].second};
        }
        if(v[i].second == 0)
        {
            two = true;
        }
        if(one && two)
        {
            break;
        }
    }
    hasSeen[p.first][p.second] = false;

    if(!one || !two)
    {
        cout<<"YES";
        return 0;
    }

    vector<pair<int, int> > curr;
    curr.push_back(p);
    vector<pair<int, int> > dirs;
    dirs.push_back({1, 0});
    dirs.push_back({-1, 0});
    dirs.push_back({0, 1});
    dirs.push_back({0, -1});
    dirs.push_back({1, 1});
    dirs.push_back({-1, 1});
    dirs.push_back({1, -1});
    dirs.push_back({-1, -1});
    for(int t = 1; curr.size(); t++)
    {
        vector<pair<int, int> > next;
        for(int i = 0; i < curr.size(); i++)
        {
            for(int j = 0; j < dirs.size(); j++)
            {
                int x = curr[i].first+dirs[j].first;
                int y = curr[i].second+dirs[j].second;

                if(x > maxX || x < 0 || y > maxY || y < 0)
                {
                    continue;
                }
                if(!hasSeen[x][y])
                {
                    continue;
                }
                if(y == 0)
                {
                    cout<<"NO";
                    return 0;
                }
                next.push_back({x, y});
                hasSeen[x][y] = false;
            }
        }
        curr = next;
    }
    cout<<"YES";
    return 0;
}
