#include<bits/stdc++.h>
using namespace std;

long long n, m;

bool v[10010][10010];
vector<pair<long long, long long>>dirs={{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
long long fx, fy;
long long sx=1, sy=1;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input()
{
    cin>>n>>m;
    for (long long i=0; i<m; i++)
    {
        long long w1, w2;
        cin>>w1>>w2;
        v[w1][w2]=1;
    }
    fx=n;
    fy=n;
}

bool BFS()
{
    vector<pair<long long, long long>>curr={{sx, sy}};
    for (long long q=0; curr.size(); q++)
    {
        vector<pair<long long, long long>>next;
        for (long long i=0; i<curr.size(); i++)
        {
            for (long long j=0; j<dirs.size(); j++)
            {
                long long x=curr[i].first+dirs[j].first;
                long long y=curr[i].second+dirs[j].second;

                if (x<1 || y<1 || x>n || y>n) continue;
                if (v[x][y]==1) continue;

                if (x==fx && y==fy) return true;
                next.push_back({x, y});
                v[x][y]=1;
            }
        }
        curr=next;
    }
    return false;
}

int main ()
{
    fastIO();
    input();
    if (BFS()) cout<<"YES"<<endl;
    else cout<<"NO"<<endl;

    return 0;
}



/*
5 6
2 3
3 2
3 3
3 4
4 3
5 1
*/

